  
//Copyright (C) 2004-2013 MKTMK Moscow, Russia
//e-mail: mktmk<at>narod.ru
//e-mail: openbasicsoft<at>gmail.com
//v.1.02 12.02.2001(last modification 06.01.2013)
//Hash table

#ifndef MHASH_THIS
#define MHASH_THIS

#include <mstore.h>
#include <mvect.h>
#include <mlist.h>

#ifndef MHASH_INLINE
#define MHASH_INLINE inline
#endif

#ifndef MHASH_NULL
#define MHASH_NULL (0)
#endif

template <class typestorehash,class typecountvect,class typecountlist> class mhash;

template <class typestorehash,class typecountvect,class typecountlist>
class mhash_iterator{

mhash<typestorehash,typecountvect,typecountlist>* tableptr;
typecountvect current_list_index;
typecountvect lenvect;

void common_init_and_assign();

public:

mhash_iterator(mhash<typestorehash,typecountvect,typecountlist>* tptr=MHASH_NULL):tableptr(tptr){
common_init_and_assign();
}

typecountvect get_current_list_index(){return current_list_index;}

void set_table(mhash<typestorehash,typecountvect,typecountlist>* tptr){
tableptr=tptr;
common_init_and_assign();
}

typestorehash* next();

typecountvect get_list_index(){return current_list_index;}

};

//-------------------------------------------------------------------------------

template <class typestorehash,class typecountvect,class typecountlist>
class mhash:
public
mvect_common<
mstore_dynamicalloc<mlist<typestorehash,typecountlist>,typecountvect> >
{
public:

mhash_iterator<typestorehash,typecountvect,typecountlist> create_iterator(){
mhash_iterator<typestorehash,typecountvect,typecountlist> ret(this);
return ret;
}

typedef typestorehash tstorehash;
typedef typecountvect tcountvect;
typedef typecountlist tcountlist;

typedef
mvect_common<
mstore_dynamicalloc<mlist<typestorehash,typecountlist>,typecountvect> >
thisvector;

mhash(typecountvect s):
mvect_common<
mstore_dynamicalloc<mlist<typestorehash,typecountlist>,typecountvect> >(s){}

void put(const typestorehash* data_in,typecountvect hash1){

mlist<typestorehash,typecountlist>* ptr=
&(
(*((thisvector*)this))[
(typecountvect)(hash1% ( ((thisvector*)this)->getcount() ))]
);

ptr->seek(typecountlist());
ptr->putb(data_in);
}

template <class F>
typestorehash* findobj(F* f,typecountlist start=typecountlist(),typecountlist* num=MHASH_NULL){

mlist<typestorehash,typecountlist>* ptr=
&((*((thisvector*)this))[
(typecountvect)(f->gethash()%(((thisvector*)this)->getcount()))]);

typestorehash* ret1;
if(ptr->findobj(f,start,ptr->getcount())==true){
ret1=(typestorehash*)ptr->copy();
if(num!=MHASH_NULL) *num=ptr->tell();
}//if
else{
ret1=MHASH_NULL;
}//else
return ret1;
}

template <class F>
bool get(F* f,typestorehash* data_out,typecountlist start=typecountlist(),typecountlist* num=MHASH_NULL){

mlist<typestorehash,typecountlist>* ptr=
&((*((thisvector*)this))[
(typecountvect)(f->gethash()%(((thisvector*)this)->getcount()))]);

bool ret=ptr->findobj(f,start,ptr->getcount());
if(ret==true){
if(num!=MHASH_NULL) *num=ptr->tell();
ptr->get(data_out);
}//if
return ret;
}

template <class F>
bool replaceobj(F* f,typestorehash* data_in,typestorehash* data_out,typecountlist start=typecountlist(),typecountlist* num=MHASH_NULL){

mlist<typestorehash,typecountlist>* ptr=
&((*((thisvector*)this))[
(typecountvect)(f->gethash()%(((thisvector*)this)->getcount()))]);

bool ret=ptr->findobj(f,start,ptr->getcount());

if(ret==true){
if(num!=MHASH_NULL) *num=ptr->tell();
ptr->get(data_out);
}//if

ptr->seek(typecountlist());
ptr->putb(data_in);

return ret;
}

void clear();

template <class countcommon> countcommon getcounttable();
};

template <class typestorehash,class typecountvect,class typecountlist>
template <class countcommon>
MHASH_INLINE
countcommon mhash<typestorehash,typecountvect,typecountlist>::getcounttable(){
typecountvect i;

typecountvect lenvect=this->getcount();

countcommon sum=countcommon();

for(i=typecountvect();i!=lenvect;++i){
sum+=(*this)[i].getcount();
}//for

return sum;
}

template <class typestorehash,class typecountvect,class typecountlist>
MHASH_INLINE
void mhash<typestorehash,typecountvect,typecountlist>::clear(){

typecountvect i;
typecountvect lenvect=this->getcount();

for(i=typecountvect();i!=lenvect;++i){
(*this)[i].clear();
}//for

}

//------------------------------ iterator ----------------------------

template <class typestorehash,class typecountvect,class typecountlist>
void mhash_iterator<typestorehash,typecountvect,typecountlist>::common_init_and_assign(){

if(tableptr!=MHASH_NULL){
current_list_index=typecountvect();

typecountvect i;
lenvect=tableptr->getcount();

for(i=typecountvect();i!=lenvect;++i){
(*tableptr)[i].seek(typecountlist());
}//for
}//if
}

template <class typestorehash,class typecountvect,class typecountlist>
typestorehash* mhash_iterator<typestorehash,typecountvect,typecountlist>::next(){

typestorehash* ret=MHASH_NULL;

if(tableptr!=MHASH_NULL){

for(;;){

if(current_list_index==lenvect) break;

mlist<typestorehash,typecountlist>* ptr=&((tableptr->c_str())[current_list_index]);

typecountlist lenlist=ptr->getcount();

if(lenlist==typecountlist()){
++current_list_index;
continue;
}//if

ret=(typestorehash*)ptr->copy();
ptr->next();
typestorehash* ret1=(typestorehash*)ptr->copy();

if(ret==ret1) ++current_list_index;

break;
}//for

}//if

return ret;
}

#endif
