 
//Copyright (C) 1998-2013 MKTMK Moscow, Russia
//http://sourceforge.net/projects/obasic/
//http://mktmk.narod.ru
//e-mail: mktmk<at>narod.ru
//e-mail: openbasicsoft<at>gmail.com
//interpreter Open Basic (OB).

#ifndef OB_MAIN_THIS
#define OB_MAIN_THIS

//for version 1.80
//if you build Unicode version library
//you must define OB_USER_WCHAR for use Unicode input file

//common includes
#ifdef OB_USER_HEADERS
//user header
#else

#ifdef _MSC_VER

//MSVC2010

#define OB_IOS     ios
#define OB_SEEKDIR seek_dir
#define OB_BEG     beg

#include <sstream>
#include <iostream>
#include <fstream>
#include <math.h>
#include <stdlib.h>
#include <ctype.h>
#include <limits.h>
#include <time.h>

#endif

//BCB60

#ifdef __BORLANDC__

#define OB_IOS     ios
#define OB_SEEKDIR seek_dir
#define OB_BEG     beg

#include <sstream>
#include <iostream.h>
#include <fstream.h>
#include <math.h>
#include <stdlib.h>
#include <ctype.h>
#include <limits.h>
#include <time.h>

#endif

//GCC 3.2.2
#ifdef __GNUG__

#define OB_IOS     ios_base
#define OB_SEEKDIR seekdir
#define OB_BEG     beg

#include <sstream>
#include <iostream>
#include <fstream>
#include <math.h>
#include <stdlib.h>
#include <ctype.h>
#include <limits>
#include <time.h>

#endif
#endif

#define OB_VERSION_DEF 191

#ifdef OB_USER_WCHAR

#ifdef OB_USER_VERSION_CHARSPACE
#define OB_NAMESPACE_FOR_OB ob_wcharspace##OB_VERSION_DEF
#else
#define OB_NAMESPACE_FOR_OB ob_wcharspace
#endif

#else

#ifdef OB_USER_VERSION_CHARSPACE
#define OB_NAMESPACE_FOR_OB ob_charspace##OB_VERSION_DEF
#else
#define OB_NAMESPACE_FOR_OB ob_charspace
#endif

#endif

namespace OB_NAMESPACE_FOR_OB{

using namespace std;

//compilers condition
#ifdef __BORLANDC__
#define MSTORE_INLINE
#define MVECT_INLINE
#define MLIST_INLINE
#define MSTACK_INLINE
#define MHASH_INLINE
#define OB_INLINE
#endif

//containers for ob
#include <mstore.h>
#include <mvect.h>
#include <mlist.h>
#include <mstack.h>
#include <mhash.h>

//define
#ifndef OB_INLINE
#define OB_INLINE inline
#endif

#ifndef OB_NULL
#define OB_NULL (0)
#endif

//forward declarations
class ob_obasic;
class ob_par;
class ob_var;
class ob_float;
class ob_int;
class ob_str;
class ob_savewrapper;
class ob_operator;

//types of Open Basic
#ifndef OB_USER_WCHAR

typedef stringstream      ob_type_strstream;            //1 common ptr for conversion wchar->char stream
typedef ostringstream     ob_type_ostrstream;           //2 for conversion digit->string
typedef istringstream     ob_type_istrstream;           //3 for conversion string->digit
typedef string            ob_type_standartstring;       //4 for create temporary string object
typedef char              ob_type_char;                 //5 symbol type

#else

typedef wstringstream     ob_type_strstream;
typedef wostringstream    ob_type_ostrstream;
typedef wistringstream    ob_type_istrstream;
typedef wstring           ob_type_standartstring;
typedef wchar_t           ob_type_char;                 

#endif

//service types
typedef int               ob_type_arraydimension;       //6
typedef int               ob_type_arraysize;            //7
typedef streampos         ob_type_streampos;            //8
typedef int               ob_type_parnum;               //9
typedef int               ob_type_filenum;              //10
typedef int               ob_type_hashtablelength;      //11
typedef int               ob_type_stringsize;           //12
typedef int               ob_type_codeerror;            //13
typedef long int          ob_type_serialnum;            //14
typedef int               ob_type_version;              //15
typedef int               ob_type_listlength;           //16

#ifndef OB_USER_INT_AND_FLOAT

typedef float             ob_type_flo;                  //17
typedef int               ob_type_int;                  //18 

#endif

//service types
typedef int               ob_type_statictablesize;      //19
typedef int               ob_type_countnestedoperator;  //20
typedef int               ob_type_srandargument;        //21

typedef char              ob_type_small_char;           //22
typedef wchar_t           ob_type_wide_char;            //23

typedef size_t            ob_type_size_t;               //24

#ifndef OB_USER_POW

#define OB_USER_POW pow
typedef double            ob_type_pow;                  //25

#endif

typedef stringstream   ob_type_shortstrstream;          //26 for datastream

typedef istream        ob_type_istreamcommon;           //27 for common pointer
typedef ostream        ob_type_ostreamcommon;           //28 for common pointer
typedef ifstream       ob_type_ifstream;                //29 for input file structure
typedef ofstream       ob_type_ofstream;                //30 for output file structure
typedef size_t         ob_type_uintptr_t;               //31 for stream ptr hash calculation

typedef mstore_dynamicalloc<ob_type_char,ob_type_stringsize>          ob_type_d;
typedef mvect_common<ob_type_d>                                       ob_type_s;

typedef mstore_staticdatawithoutbuf<ob_type_char,ob_type_stringsize>  ob_type_d1;
typedef mvect_common<ob_type_d1>                                      ob_type_s1;

typedef mstore_dynamicalloc<ob_type_arraysize,ob_type_arraydimension> ob_type_a;
typedef mvect_common<ob_type_a>                                       ob_type_dim;

typedef mstore_dynamicalloc<ob_type_small_char,ob_type_stringsize>    ob_type_f;
typedef mvect_common<ob_type_f>                                       ob_type_string_char_small;

typedef mstore_dynamicalloc<ob_savewrapper,ob_type_arraysize>         ob_type_v1;
typedef mvect_common<ob_type_v1>                                      ob_type_array_variable;

#ifndef OB_USER_MAXLENGTHSTRING
#define OB_USER_MAXLENGTHSTRING (4096)
#endif

#ifndef OB_USER_MAXNUMPAR
#define OB_USER_MAXNUMPAR (64)
#endif

#ifndef OB_USER_MAXARRAYDIMENTION
#define OB_USER_MAXARRAYDIMENTION (20)
#endif

#ifndef OB_USER_MAXNUMPARSUBROUTINE
#define OB_USER_MAXNUMPARSUBROUTINE (64)
#endif

//const of Open Basic
//max length string in input operator
const ob_type_stringsize      ob_maxlengthstring=OB_USER_MAXLENGTHSTRING;
const ob_type_parnum          ob_maxnumpar=OB_USER_MAXNUMPAR;
const ob_type_arraydimension  ob_maxarraydimention=OB_USER_MAXARRAYDIMENTION;
const ob_type_statictablesize ob_maxnumoperator=30;
//for version 1.91
const ob_type_parnum          ob_maxnumparsubroutine=OB_USER_MAXNUMPARSUBROUTINE;

#define OB_CHARDEFINE(xxx,MMM)                        \
const ob_type_char ob_const_at         xxx MMM##'@';  \
const ob_type_char ob_const_equ        xxx MMM##'=';  \
const ob_type_char ob_const_cr         xxx MMM##'\r'; \
const ob_type_char ob_const_lf         xxx MMM##'\n'; \
const ob_type_char ob_const_asterisk   xxx MMM##'*';  \
const ob_type_char ob_const_slash      xxx MMM##'/';  \
const ob_type_char ob_const_bslash     xxx MMM##'\\'; \
const ob_type_char ob_const_plus       xxx MMM##'+';  \
const ob_type_char ob_const_minus      xxx MMM##'-';  \
const ob_type_char ob_const_pow        xxx MMM##'^';  \
const ob_type_char ob_const_lp         xxx MMM##'(';  \
const ob_type_char ob_const_rp         xxx MMM##')';  \
const ob_type_char ob_const_sc         xxx MMM##';';  \
const ob_type_char ob_const_colon      xxx MMM##':';  \
const ob_type_char ob_const_comma      xxx MMM##',';  \
const ob_type_char ob_const_lp1        xxx MMM##'<';  \
const ob_type_char ob_const_rp1        xxx MMM##'>';  \
const ob_type_char ob_const_quotes     xxx MMM##'\"'; \
const ob_type_char ob_const_quotes1    xxx MMM##'\''; \
const ob_type_char ob_const_point      xxx MMM##'.';  \
                                                      \
const ob_type_char ob_const_0          xxx MMM##'0';  \
const ob_type_char ob_const_1          xxx MMM##'1';  \
const ob_type_char ob_const_2          xxx MMM##'2';  \
const ob_type_char ob_const_3          xxx MMM##'3';  \
const ob_type_char ob_const_4          xxx MMM##'4';  \
const ob_type_char ob_const_5          xxx MMM##'5';  \
const ob_type_char ob_const_6          xxx MMM##'6';  \
const ob_type_char ob_const_7          xxx MMM##'7';  \
const ob_type_char ob_const_8          xxx MMM##'8';  \
const ob_type_char ob_const_9          xxx MMM##'9';  \
                                                      \
const ob_type_char ob_const_a          xxx MMM##'a';  \
const ob_type_char ob_const_b          xxx MMM##'b';  \
const ob_type_char ob_const_c          xxx MMM##'c';  \
const ob_type_char ob_const_d          xxx MMM##'d';  \
const ob_type_char ob_const_e          xxx MMM##'e';  \
const ob_type_char ob_const_f          xxx MMM##'f';  \
const ob_type_char ob_const_A          xxx MMM##'A';  \
const ob_type_char ob_const_B          xxx MMM##'B';  \
const ob_type_char ob_const_C          xxx MMM##'C';  \
const ob_type_char ob_const_D          xxx MMM##'D';  \
const ob_type_char ob_const_E          xxx MMM##'E';  \
const ob_type_char ob_const_F          xxx MMM##'F';  \
                                                      \
const ob_type_char ob_const_space      xxx MMM##' ';  \
const ob_type_char ob_const_tab        xxx MMM##'\t'; \
const ob_type_char ob_const_ff         xxx MMM##'\f'; \
                                                      \
const ob_type_char ob_const_hex        xxx MMM##'x';  \
const ob_type_char ob_const_HEX        xxx MMM##'X';  \
                                                      \
const ob_type_char ob_const_underscore xxx MMM##'_';  \
const ob_type_char ob_const_strlabel   xxx MMM##'$';  \
const ob_type_char ob_const_intlabel   xxx MMM##'%';

const ob_type_char ob_const_endstring=0;
const ob_type_small_char ob_const_endstring_small=0;

#ifndef OB_USER_WCHAR

const ob_type_char ob_const_sharp    ='#';

OB_CHARDEFINE(=,)

#else

const ob_type_char ob_const_sharp    =L'#';

const ob_type_char ob_const_nel      =0x0085;//UNICODE new line
const ob_type_char ob_const_ls       =0x2028;//UNICODE line selector
const ob_type_char ob_const_ps       =0x2029;//UNICODE paragraph selector

OB_CHARDEFINE(=,L)

#endif

#define OB_STRINGDEFINE(str) str

const ob_type_wide_char ob_byte_order_mark1  =0xFEFF;

#ifndef OB_USER_HASHLENGTH
#define OB_USER_HASHLENGTH (131)
#endif

#ifndef OB_USER_LOCAL_OBJECT_HASHLENGTH
#define OB_USER_LOCAL_OBJECT_HASHLENGTH (131)
#endif

//length of hash table
const ob_type_hashtablelength ob_hashlength=OB_USER_HASHLENGTH;
const ob_type_hashtablelength ob_hashlength_local_object=OB_USER_LOCAL_OBJECT_HASHLENGTH;
const ob_type_hashtablelength ob_starthashvalue=1;//must be >=0

class ob_type_string:public ob_type_s{
public:
ob_type_string(){}//for ob_str default constructor
ob_type_string(ob_type_stringsize c):ob_type_s(c){}//for curr. string in ob_lex
ob_type_string(ob_type_char* data1,ob_type_stringsize c):
ob_type_s(data1,c){}//for create string without new call strlen in prim()
ob_type_string(ob_type_char* data1)://for create string after return char* from user func.
ob_type_s(data1,ob_type_char(),ob_maxlengthstring){}
};

//prototypes
ob_type_hashtablelength ob_hash(ob_type_char* data,ob_type_stringsize l);
ob_type_hashtablelength ob_hash(void* ptr);

const ob_type_char*
ob_getstringparam(
const ob_type_parnum *descrc,
const ob_type_char* parc,
const ob_type_parnum i);

ob_type_stringsize ob_strlen(ob_type_char* str);
ob_type_stringsize ob_strlen_small(ob_type_small_char* str);
void ob_strcpy(ob_type_char* datadst,const ob_type_char* datasrc);

//prototypes
//for version 1.80
#ifdef OB_USER_WCHAR
void wchar2char(ob_type_string_char_small* sfn,ob_type_char* name);
void char2wchar(ob_type_string* name,ob_type_small_char* sfn);
#endif

//prototypes
//for version 1.90
void ob_wstream_to_stream(ob_type_shortstrstream* datastream,ob_type_standartstring* st);

class ob_type_namestatic:public ob_type_s1{
static ob_type_char zero_object;
public:
ob_type_namestatic():ob_type_s1(&zero_object,ob_strlen(&zero_object)){}//for member ob_lex
ob_type_namestatic(ob_type_char* data1):ob_type_s1(data1,ob_strlen(data1)){}//for findcommon
ob_type_namestatic(ob_type_char* data1,ob_type_stringsize c):ob_type_s1(data1,c){}//for get_lex
ob_type_namestatic(ob_type_string* s):ob_type_s1(s->getdata(),s->getcount()){}//for CHECKLOAD
ob_type_hashtablelength gethash() const {return ob_hash(data,count);}
};

class ob_type_name:public ob_type_s{
ob_type_hashtablelength hashvalue;
public:
ob_type_name(){hashvalue=ob_hash(data,count);}//for local ob_label object
ob_type_name(const ob_type_name& name):ob_type_s((ob_type_s)name),hashvalue(name.hashvalue){}//for ob_forfor
ob_type_name(const ob_type_namestatic& name):ob_type_s(name.getdata(),name.getcount()),hashvalue(name.gethash()){}//for ob_label and ob_varbase
ob_type_hashtablelength gethash(){return hashvalue;}//for insert new var in tables

ob_type_name& operator =(const ob_type_name& name){
*((ob_type_s*)this)=*((ob_type_s*)&name);
hashvalue=name.hashvalue;
return *this;
}

ob_type_name& operator =(const ob_type_string& name){
*((ob_type_s*)this)=*((ob_type_s*)&name);
hashvalue=ob_hash(data,count);
return *this;
}

};

const ob_type_codeerror ob_basecodeerror=0;

#define OB_CODEERROR(ecode)              \
const ob_type_codeerror ob_err##ecode=(ob_basecodeerror+(ecode));

#define OB_CODEERRORGROUP(e0,e1,e2,e3,e4,e5,e6,e7,e8,e9) \
OB_CODEERROR(e0)                                         \
OB_CODEERROR(e1)                                         \
OB_CODEERROR(e2)                                         \
OB_CODEERROR(e3)                                         \
OB_CODEERROR(e4)                                         \
OB_CODEERROR(e5)                                         \
OB_CODEERROR(e6)                                         \
OB_CODEERROR(e7)                                         \
OB_CODEERROR(e8)                                         \
OB_CODEERROR(e9)

OB_CODEERRORGROUP(  0,  1,  2,  3,  4,  5,  6,  7,  8,  9)
OB_CODEERRORGROUP( 10, 11, 12, 13, 14, 15, 16, 17, 18, 19)
OB_CODEERRORGROUP( 20, 21, 22, 23, 24, 25, 26, 27, 28, 29)
OB_CODEERRORGROUP( 30, 31, 32, 33, 34, 35, 36, 37, 38, 39)
OB_CODEERRORGROUP( 40, 41, 42, 43, 44, 45, 46, 47, 48, 49)
OB_CODEERRORGROUP( 50, 51, 52, 53, 54, 55, 56, 57, 58, 59)
OB_CODEERRORGROUP( 60, 61, 62, 63, 64, 65, 66, 67, 68, 69)
OB_CODEERRORGROUP( 70, 71, 72, 73, 74, 75, 76, 77, 78, 79)
OB_CODEERRORGROUP( 80, 81, 82, 83, 84, 85, 86, 87, 88, 89)
OB_CODEERRORGROUP( 90, 91, 92, 93, 94, 95, 96, 97, 98, 99)
OB_CODEERRORGROUP(100,101,102,103,104,105,106,107,108,109)
OB_CODEERRORGROUP(110,111,112,113,114,115,116,117,118,119)
OB_CODEERRORGROUP(120,121,122,123,124,125,126,127,128,129)

void ob_errorgeneration(ob_type_codeerror e);//do not inline for debug

#define OB_ERR(eee) ob_errorgeneration(eee);

//----------------------------------------------------------- the classes

class ob_istream_base{

ob_type_hashtablelength hashvalue;

protected:

ob_type_istreamcommon* streamptr;

public:

ob_istream_base():streamptr(OB_NULL),hashvalue(ob_hash(OB_NULL)){}
ob_istream_base(const ob_istream_base& i1):streamptr(i1.streamptr),hashvalue(i1.hashvalue){}
ob_istream_base(ob_type_istreamcommon* streamptr1):streamptr(streamptr1),hashvalue(ob_hash(streamptr1)){}

ob_istream_base& operator =(const ob_istream_base& d){
streamptr=d.streamptr;
hashvalue=d.hashvalue;
return *this;
}

bool good(){return streamptr->good();}
bool eof(){return streamptr->eof();}

ob_type_hashtablelength gethash(){return hashvalue;}

void restore(){setposition(ob_type_streampos());}

//for setposition in label
void set_stream(ob_type_istreamcommon* streamptr1){
streamptr=streamptr1;
hashvalue=ob_hash(streamptr1);
}

//for init global label and for ob_obasic
ob_type_istreamcommon* get_stream() const {return streamptr;}

bool iszero(){if(streamptr==OB_NULL) return true; else return false;}

ob_type_streampos getposition() const {
return streamptr->tellg();
}

void setposition(ob_type_streampos pos,OB_IOS::OB_SEEKDIR d=OB_IOS::OB_BEG){
streamptr->clear();//clear need if last CR-LF is not present and EOF occured
streamptr->seekg(pos,d);
}

};

class ob_istream: public ob_istream_base{

ob_type_streampos prevposition;

public:

ob_istream():ob_istream_base(),prevposition(ob_type_streampos()){}
ob_istream(const ob_istream& i1):ob_istream_base(i1),prevposition(i1.prevposition){}
ob_istream(ob_type_istreamcommon* streamptr1):ob_istream_base(streamptr1){}

void get(ob_type_small_char& ch){
prevposition=streamptr->tellg();
streamptr->get(ch);
}

ob_istream& operator =(const ob_istream& d){
(*(ob_istream_base*)this)=(ob_istream_base)d;
prevposition=d.prevposition;
return *this;
}

ob_istream& operator =(const ob_istream_base& d){
*((ob_istream_base*)this)=d;
return *this;
}

void get(ob_type_wide_char& ch){

prevposition=streamptr->tellg();

ob_type_wide_char ch1=0;
ob_type_small_char* pch=(ob_type_small_char*)(&ch1);

ob_type_size_t ls=sizeof(ob_type_wide_char);
ob_type_size_t i;
ob_type_small_char ch2;

for(i=0;i!=ls;++i){
streamptr->get(ch2);

if(eof()) break;
if(!good()) OB_ERR(ob_err9);

pch[i]=ch2;
}//for

ch=ch1;
}

void putback(){setposition(prevposition);}

};

class ob_ostream{

ob_type_ostreamcommon* streamptr;

void put_common_symbol(ob_type_ostrstream* immos){

ob_type_standartstring st1=immos->str();
const ob_type_small_char* p=(const ob_type_small_char*)st1.c_str();

ob_type_stringsize l=st1.length()*sizeof(ob_type_char);
ob_type_stringsize i;

for(i=0;i!=l;++i){
put(p[i]);
}//for

}

public:

bool iszero(){if(streamptr==OB_NULL) return true; else return false;}

virtual void put(const ob_type_wide_char& ch){

ob_type_wide_char ch1=ch;

ob_type_size_t ls=sizeof(ob_type_wide_char);
ob_type_size_t i;
ob_type_small_char* pch1=(ob_type_small_char*)&ch1;

for(i=0;i!=ls;++i) streamptr->put(pch1[i]);

}

ob_ostream():streamptr(OB_NULL){}

void set_stream(ob_type_ostreamcommon* streamptr1){
streamptr=streamptr1;
}

virtual void put(const ob_type_small_char& ch){streamptr->put(ch);}

bool good(){return streamptr->good();}
bool eof(){return streamptr->eof();}

void putendl(){

ob_type_ostrstream immos;
immos<<endl;

put_common_symbol(&immos);
}

template<class T>
void putdigit(T var){

ob_type_ostrstream immos;
immos<<var;

put_common_symbol(&immos);
}

//for filestream in OPEN operator
void put_byte_order_mark(){
ob_type_wide_char ch=ob_byte_order_mark1;
ob_ostream::put(ch);
}

};

//-----------------------------------------------------------

//for version 1.80
//convertors

//isspace
template <class Tchar>
bool ob_isspace(Tchar ch){
bool ret;
switch(ch){
case ob_const_space:case ob_const_tab:case ob_const_ff:ret=true;break;
default:ret=false;break;
}//switch
return ret;
}

//iseol
template <class Tchar>
bool ob_iseol(Tchar ch){
bool ret;
switch(ch){
case ob_const_cr         ://3
case ob_const_lf         ://4

//for version 1.90
#ifdef OB_USER_WCHAR
case ob_const_nel        ://24
case ob_const_ls         ://25
case ob_const_ps         ://26
#endif

ret=true;break;
default:ret=false;break;
}//switch
return ret;
}

//isdelim
template <class Tchar>
bool ob_isdelim(Tchar ch){

bool ret=ob_iseol<Tchar>(ch);
if(ret==false){

switch(ch){
case ob_const_at         ://1
case ob_const_equ        ://2
case ob_const_cr         ://3
case ob_const_lf         ://4
case ob_const_asterisk   ://5
case ob_const_slash      ://6
case ob_const_plus       ://7
case ob_const_minus      ://8
case ob_const_pow        ://9
case ob_const_lp         ://10
case ob_const_rp         ://11
case ob_const_sc         ://12
case ob_const_colon      ://13
case ob_const_comma      ://14
case ob_const_lp1        ://15
case ob_const_rp1        ://16
case ob_const_quotes     ://17
case ob_const_quotes1    ://18
case ob_const_point      ://29
case ob_const_space      ://20
case ob_const_tab        ://21
case ob_const_ff         ://22
case ob_const_sharp      ://23

//for version 1.90
#ifdef OB_USER_WCHAR
case ob_const_nel        ://24
case ob_const_ls         ://25
case ob_const_ps         ://26
#endif

ret=true;break;
default:ret=false;break;
}//switch

}//if
return ret;
}

//-----------------------------------------------------------

//some local classes
//variable
enum ob_type_ident {OB_IDENTFLO,OB_IDENTINT,OB_IDENTSTR,OB_NOIDENT};

#define OB_DECLF(name,typearg) ob_var* name(typearg* a)

#define OB_DECLSETF(start,typearg,stop)                                      \
start OB_DECLF(add_v,typearg) stop;start OB_DECLF(sub_v,typearg) stop;       \
start OB_DECLF(mul_v,typearg) stop;start OB_DECLF(div_v,typearg) stop;       \
start OB_DECLF(pww_v,typearg) stop;start OB_DECLF(asg_v,typearg) stop;       \
start bool compare_v(const typearg* a,ob_var::ob_type_if currentlexif) const stop;

#define OB_DECLSETALLF(nameclass,start,stop)                    \
OB_DECLSETF(start,ob_var,stop)                                  \
OB_DECLSETF(start,ob_float,stop)                                \
OB_DECLSETF(start,ob_int,stop)                                  \
OB_DECLSETF(start,ob_str,stop)                                  \
start ob_var* uniminus_v() stop;                                \
start bool eq_v() const stop;                                   \
start ob_var* duplicate_v() stop;                               \
start ob_type_ident isA_v() const stop;                         \
start void tostream_v(ob_ostream* out) stop;                    \
start void topar_v(ob_par* p,const ob_type_parnum i) stop;      \
start void cast_v(ob_type_flo* a) stop;                         \
start void cast_v(ob_type_int* a) stop;                         \
start void cast_v(ob_type_char** a) stop;                       \
start ob_type_string* getstring_v() stop;                       \
start ~nameclass(){}

//base class for types variable obasic
class ob_var{
public:
enum ob_type_if{LESSIF,GREATIF,EQVIF,LESSEQVIF,GREATEQVIF,NOTEQVIF};
OB_DECLSETALLF(ob_var,virtual,=0)
virtual ob_type_stringsize size_v()=0;
};

//derived class for types variable obasic
class ob_float:public ob_var{
friend class ob_int;
friend class ob_str;

ob_type_flo var;
public:
typedef ob_type_flo typedatavar;

ob_float();
ob_float(ob_type_char*);
ob_float(ob_type_flo);

OB_DECLSETALLF(ob_float, , )

ob_type_stringsize size_v(){return sizeof(var);}
};

class ob_int:public ob_var{
friend class ob_float;
friend class ob_str;

ob_type_int var;
public:
typedef ob_type_int typedatavar;

ob_int();
ob_int(ob_type_char*);
ob_int(ob_type_int);

OB_DECLSETALLF(ob_int, , )

ob_type_stringsize size_v(){return sizeof(var);}
};

class ob_str:public ob_var{
friend class ob_float;
friend class ob_int;

ob_type_string var;
public:
typedef ob_type_char* typedatavar;

ob_str();//for array of string
ob_str(ob_type_char* s);//for return ob_type_char* from user function
ob_str(ob_type_char* s,ob_type_stringsize l);//for create ob_str from static string
ob_str(ob_type_string& s);//for duplicate string

OB_DECLSETALLF(ob_str, , )

ob_type_stringsize size_v(){return var.getcount()-1;}
};

#define OB_OPERATIONWRAPPER(name)                         \
void name(ob_savewrapper* a){                             \
ob_var* tmpptr=ptr->name##_v(a->ptr);                     \
if(tmpptr==ptr){ a->clear();} else {clear();transfer(a);} \
}

//some realization
class ob_savewrapper{
ob_var* ptr;

ob_savewrapper(const ob_savewrapper& s):ptr(s.ptr){}
ob_savewrapper& operator =(const ob_savewrapper& s){return *this;}

public:

ob_savewrapper():ptr(OB_NULL){}
ob_savewrapper(ob_var* p):ptr(p){}

void setptr(ob_var* s){
if((ptr!=OB_NULL)&&(s!=OB_NULL)){
clear();//for eliminate double delete
OB_ERR(ob_err78)
}//if
ptr=s;

}
bool iszero() const {if(ptr==OB_NULL) return true; else return false;}
void clear(){delete ptr;ptr=OB_NULL;}

~ob_savewrapper(){delete ptr;}

void transfer(ob_savewrapper* d){//for ob_forfor and vararray
setptr(d->ptr);
d->setptr(OB_NULL);
}

OB_OPERATIONWRAPPER(add)
OB_OPERATIONWRAPPER(sub)
OB_OPERATIONWRAPPER(mul)
OB_OPERATIONWRAPPER(div)
OB_OPERATIONWRAPPER(pww)

void asg(ob_savewrapper* a){
ptr->asg_v(a->ptr);//do not check pointer because asgv always return own pointer
a->clear();
}

bool compare(const ob_savewrapper* a,ob_var::ob_type_if currentlexif) const {return ptr->compare_v(a->ptr,currentlexif);}

ob_var* uniminus(){return ptr->uniminus_v();}
bool eq() const {return ptr->eq_v();}
ob_var* duplicate(){return ptr->duplicate_v();}
ob_type_ident isA() const {return ptr->isA_v();}
void tostream(ob_ostream* out){ptr->tostream_v(out);}
void topar(ob_par* p,const ob_type_parnum i){ptr->topar_v(p,i);}       
void cast(ob_type_flo* a){ptr->cast_v(a);}
void cast(ob_type_int* a){ptr->cast_v(a);}
void cast(ob_type_char** a){ptr->cast_v(a);}
ob_type_string* getstring(){return ptr->getstring_v();}
ob_type_stringsize size(){return ptr->size_v();}
};

class ob_data_for_jump_local{
ob_type_streampos label;
public:

ob_data_for_jump_local(const ob_type_streampos p):label(p){}

virtual ~ob_data_for_jump_local(){}

void set(const ob_type_streampos p){label=p;}//for forfor

virtual void setposition(ob_istream* in1){
in1->setposition(label);
}

};

class ob_data_for_jump_global: public ob_data_for_jump_local{

ob_istream_base i;

void set(const ob_type_streampos p){OB_ERR(ob_err106);}

public:

ob_data_for_jump_global():ob_data_for_jump_local(ob_type_streampos()){}//for operreturn
ob_data_for_jump_global(const ob_type_streampos p,ob_istream *i1):ob_data_for_jump_local(p),i(*i1){}//for ob_label_global
ob_data_for_jump_global(ob_istream *i1):ob_data_for_jump_local(i1->getposition()),i(*i1){}//for opergo

virtual ~ob_data_for_jump_global(){}

virtual void setposition(ob_istream* in1){
if(i.iszero()==true) OB_ERR(ob_err107);
*in1=i;
ob_data_for_jump_local::setposition(in1);
}

};

class ob_label_forfor: public ob_type_name, public ob_data_for_jump_local{
public:

//label for forfor create from bigname
ob_label_forfor(ob_type_name* name,ob_type_streampos p):
ob_type_name(*name),ob_data_for_jump_local(p){}

virtual ~ob_label_forfor(){}
};

class ob_label_local: public ob_type_name, public ob_data_for_jump_local{
public:

//label for local tablelabel
ob_label_local(ob_type_namestatic* name,ob_type_streampos p):
ob_type_name(*name),ob_data_for_jump_local(p){}

virtual ~ob_label_local(){}
};

class ob_label_global:public ob_type_name, public ob_data_for_jump_global{
public:

//label for global tablelabel
ob_label_global(
ob_type_namestatic* name,
ob_type_streampos p,
ob_istream* i1):
ob_type_name(*name),ob_data_for_jump_global(p,i1){}

virtual ~ob_label_global(){}
};

class ob_forfor:public ob_label_forfor{
ob_savewrapper lastvalue,step;
ob_var::ob_type_if typeifforcheckinfor;
public:

ob_forfor(ob_type_name* name,ob_type_streampos p,
ob_savewrapper* l,ob_savewrapper* s):ob_label_forfor(name,p){
lastvalue.transfer(l);
step.transfer(s);
ob_savewrapper zero(new ob_int(ob_type_int()));
if(step.compare(&zero,ob_var::LESSIF)==false)
typeifforcheckinfor=ob_var::LESSEQVIF;
else
typeifforcheckinfor=ob_var::GREATEQVIF;
}

~ob_forfor(){}

void add(ob_savewrapper* var){
ob_savewrapper step1(step.duplicate());
ob_savewrapper var1(var->duplicate());
var1.add(&step1);
var->asg(&var1);
}

bool check(ob_savewrapper* var){
return var->compare(&lastvalue,typeifforcheckinfor);
}

};

//variable for store
class ob_varbase:public ob_type_name{
public:
ob_varbase(ob_type_namestatic& name):ob_type_name(name){}
virtual ob_type_name bigname()=0;//for FOR operator
virtual ob_savewrapper* get()=0;
virtual ~ob_varbase(){}//do not need virtual destructor because do not delete varone and vararray as varbase 
};

class ob_varone:public ob_varbase{
ob_savewrapper value;
public:

ob_varone(ob_type_namestatic& name);

ob_type_ident isA(){return value.isA();}

ob_savewrapper* get(){return (&value);}

ob_type_name bigname();//for FOR operator
~ob_varone(){}
};

//array for store
class ob_vararray:public ob_varbase{
ob_type_array_variable value;
ob_type_dim dimension;
ob_type_dim dimension1;
ob_type_arraysize sizecurrent;
public:

ob_vararray(ob_type_namestatic& name,ob_type_dim* ptrdim);

ob_type_ident isA(){return value[0].isA();}

ob_savewrapper* get(){return &(value[sizecurrent]);}
void setsize(ob_type_dim* ptrdimcurrent);

const ob_type_arraysize* getsize(ob_type_arraydimension* kr){
*kr=dimension.getcount();
return dimension.c_str();
}

//return value because need modify name for FOR oper.
ob_type_name bigname();

virtual ~ob_vararray(){}
};

class ob_base_file{

ob_type_filenum number;

public:
ob_base_file(ob_type_filenum num):number(num){}
virtual ~ob_base_file(){}
ob_type_filenum getnum(){return number;}

virtual void get_stream(ob_istream** ptr)=0;
virtual void get_stream(ob_ostream** ptr)=0;
};

class ob_input_file: public ob_base_file{

ob_type_ifstream file;

ob_istream iss;

public:

ob_input_file(
ob_type_char* name,
ios::openmode mode,
ob_type_filenum num):ob_base_file(num){

file.open(name,mode);
iss.set_stream(&file);
}

~ob_input_file(){
file.close();
}

void get_stream(ob_istream** ptr){*ptr=&iss;}
void get_stream(ob_ostream** ptr){OB_ERR(ob_err97);}
};

class ob_output_file: public ob_base_file{

ob_type_ofstream file;

ob_ostream oss;

public:

ob_output_file(
ob_type_char* name,
ios::openmode mode,
ob_type_filenum num):ob_base_file(num){

file.open(name,mode);
oss.set_stream(&file);
}

~ob_output_file(){
file.close();
}

void get_stream(ob_istream** ptr){OB_ERR(ob_err98);}
void get_stream(ob_ostream** ptr){*ptr=&oss;}
};

class ob_api:public ob_type_name{
public:
ob_api(ob_type_char* a):ob_type_name(a){}
virtual void run(ob_obasic* ptr,ob_par* p,ob_savewrapper* v)=0;
virtual ~ob_api(){}
};

class ob_lex{
public:

enum typelex{
PLUS,MINUS,MUL,DIV,POWER,ASSIGN,LP,RP,STRING,SEMICOLON,COMMA,ENDPROGRAMM,EOL,
LESS,GREAT,SHARP,BREAKPOINT,
DECINTNUMBER,HEXINTNUMBER,FLOATNUMBER,
FUNC,OPERATOR,
OLDVARIABLE,OLDARRAY,NEWNAME,
BAD,LABEL,BYTE_ORDER_MARK1
};

private:

ob_obasic*         ptrbasic;

typelex            currentlex;
ob_type_string     currentlexasstring;
ob_type_namestatic currentlexasnamestatic;

ob_operator*       currentoperator;//for find operator

ob_api*            currentfunction;
ob_varone*         currentvar;
ob_vararray*       currentarray;

ob_type_streampos  previousptr;

ob_istream         in;

enum typego{GOTO,GOSUB};
void opergo(typego tg);
void dopinput(ob_lex* lex);
//for version 1.50
void findkeywordforif(ob_type_namestatic* kwrd1,ob_type_namestatic* kwrd2);

//expression calculation
void power(ob_savewrapper* left);
void term(ob_savewrapper* left);
void prim(ob_savewrapper* left);

//for version 1.50
//for ob_lex find CR-LF
void findother(ob_type_char other){

ob_type_char ch;
in.get(ch);

if(in.good()==false){
OB_ERR(ob_err9);
}//if
else{
if((in.eof()==false)&&(ch!=other)) in.putback();
}//else
}

void format_data(ob_type_char ch,typelex tl);

public:

void findeol();

ob_api*            getcurrentfunction(){return currentfunction;}  //for ob_obasic::run
ob_operator*       getcurrentoperator(){return currentoperator;}  //for ob_obasic::run

ob_lex(ob_type_istreamcommon* i):currentlex(ENDPROGRAMM),currentlexasstring(ob_maxlengthstring){
in.set_stream(i);
}

void set_basic_ptr(ob_obasic* p){ptrbasic=p;}//msvc set warning C4355 if prev and next init in ctor init list

~ob_lex(){}

void expr(ob_savewrapper* left);

typelex get_lex();//token analizer

ob_istream* get_input_stream(){return &in;}//for set UNICODE flags and input stream

bool iszero(){return in.iszero();}

typelex gettypecurrentlex() const {return currentlex;}

ob_type_namestatic* getstring(){return &currentlexasnamestatic;}

ob_type_streampos getposition() const {return in.getposition();}//for ob_par::work ob_obasic::load operforfor

void putbacklex(){in.setposition(previousptr);}

void restore(){//for DATA operator
in.restore();
get_lex();
}

void getsizearray(ob_type_dim* ptrdimcurrent);//for ob_lex::extractvar and ob_lex::operdim

ob_varbase* extractvar();//for ob_lex::operXXXX
ob_varbase* extractvarwithoutcreate();//for ob_obasic::readvar

void workvariable(ob_savewrapper* left);//for ob_obasic::run and ob_lex::operfor

void setposition(ob_data_for_jump_local* lab){lab->setposition(&in);}
void setposition(ob_type_streampos pos){in.setposition(pos);}//for restoreinputpointer and get_lex

void partostream(ob_type_ostrstream* name,ob_type_streampos one);//for ob_api create string of all parameters

template <class ob_type>
typename ob_type::typedatavar gettypevalue(){//do not use for ob_str

ob_savewrapper tmp;
expr(&tmp);

typename ob_type::typedatavar ret;

tmp.cast(&ret);

return ret;
}

//operators
void operprint();     //1
void operinput();     //2
void operif();        //3
void operfor();       //4
void opernext();      //5
void opergoto();      //6
void opergosub();     //7
void operreturn();    //8
void operlet();       //9
void operdim();       //10
void operstop();      //11
void operend();       //12
void operrem();       //13
void operopen();      //14
void operclose();     //15
void operkill();      //16
void operread();      //17
void operdata();      //18
void operrestore();   //19
void operrandomize(); //20
void operelse();      //21
void operendif();     //22

//for version 1.91
void opersub();       //23
void operendsub();    //24
void operexitsub();   //25
void opercheckload_run(); //26.1 two methods for one operator
void opercheckload_load();//26.2 two methods for one operator

};//stop class ob_lex

class ob_base_class_for_IO_service{
public:
ob_base_class_for_IO_service(){}
virtual ~ob_base_class_for_IO_service(){}
virtual void run_before(ob_obasic* basicptr)=0;
virtual void run_after(ob_obasic* basicptr)=0;
};

typedef void (ob_lex::*ob_oper)();

class ob_operator:public ob_type_namestatic{
private:

ob_oper ptroper_for_work;
ob_oper ptroper_for_load;

ob_base_class_for_IO_service* ptrbreak;

public:

ob_operator():ptroper_for_work(OB_NULL),ptroper_for_load(OB_NULL),ptrbreak(OB_NULL){}//for trailer of operator table

ob_operator(ob_type_namestatic* name,ob_oper p,ob_oper p_for_load=OB_NULL)
:ob_type_namestatic(name->getdata(),name->getcount()),ptroper_for_work(p),ptroper_for_load(p_for_load),ptrbreak(OB_NULL){}

//run function-member of ob_operator as data-member of ob_lex
void run_for_work(ob_lex* lex){(lex->*ptroper_for_work)();}//indeed 
void run_for_load(ob_lex* lex){if(ptroper_for_load!=OB_NULL) (lex->*ptroper_for_load)();}//indeed

void set_get_break(ob_base_class_for_IO_service* ptrbreak1){ptrbreak=ptrbreak1;}
void set_get_break(ob_base_class_for_IO_service** ptrbreak1) const {*ptrbreak1=ptrbreak;}

void runbefore(ob_obasic* basicptr){if(ptrbreak!=OB_NULL) ptrbreak->run_before(basicptr);}
void runafter(ob_obasic* basicptr){if(ptrbreak!=OB_NULL) ptrbreak->run_after(basicptr);}
};

#define OB_NUMTYPES 3

#define OB_TYPEFLO 0
#define OB_TYPEINT 1
#define OB_TYPESTR 2

class ob_par{
public:
ob_type_parnum* mo[OB_NUMTYPES];
ob_type_ostrstream *name,*pc;
ob_type_flo *pf;
ob_type_int *pi;
void initpar();
ob_par(){initpar();}
void work(ob_lex* p);
void deletepar();
~ob_par(){deletepar();}
};

//for API defines

#define OB_TYPEFUNAPI(name,typeret)                      \
typedef typeret (*name)(                                 \
ob_obasic* basic_ptr,                                    \
const ob_type_char* parstring,                           \
const ob_type_parnum *descrf,                            \
const ob_type_parnum *descri,                            \
const ob_type_parnum *descrc,                            \
const ob_type_flo* parf,                                 \
const ob_type_int* pari,                                 \
const ob_type_char* parc);

#define OB_DECLARE_USER_FUNCTION(name,typeret)           \
typeret name(                                            \
ob_obasic* basic_ptr,                                    \
const ob_type_char* parstring,                           \
const ob_type_parnum *descrf,                            \
const ob_type_parnum *descri,                            \
const ob_type_parnum *descrc,                            \
const ob_type_flo* parf,                                 \
const ob_type_int* pari,                                 \
const ob_type_char* parc)

#define OB_DECLFUNAPI(name,typeret)                      \
typeret name(                                            \
ob_obasic* ptr,                                          \
const ob_type_char* parstring,                           \
const ob_type_parnum *descrf,                            \
const ob_type_parnum *descri,                            \
const ob_type_parnum *descrc,                            \
const ob_type_flo* parf,                                 \
const ob_type_int* pari,                                 \
const ob_type_char* parc)

OB_TYPEFUNAPI(ob_type_flofun,ob_type_flo)
OB_TYPEFUNAPI(ob_type_intfun,ob_type_int)
OB_TYPEFUNAPI(ob_type_charfun,ob_type_char*)

enum ob_type_del{OB_DELETE,OB_NODELETE};

#define OB_CLASSAPI(name,typeptr,dopdata,construct)             \
class name:public ob_api{                                       \
typeptr ptrfun;                                                 \
dopdata                                                         \
public:                                                         \
typedef typeptr typefun;                                        \
construct;                                                      \
void run(ob_obasic* ptr,ob_par* p,ob_savewrapper* v);           \
~name(){}                                                       \
};

OB_CLASSAPI(ob_apif,ob_type_flofun,,ob_apif(ob_type_char* a,ob_type_flofun))
OB_CLASSAPI(ob_apii,ob_type_intfun,,ob_apii(ob_type_char* a,ob_type_intfun))
OB_CLASSAPI(ob_apic,ob_type_charfun,ob_type_del dt;,
ob_apic(ob_type_char* a,ob_type_charfun,ob_type_del d))

extern const ob_type_small_char* ob_englmessage[];

template <class typestore>
class ob_wrapper_for_table{

typestore* ptr;

public:

typedef typestore tstore;

ob_wrapper_for_table():ptr(OB_NULL){}
ob_wrapper_for_table(typestore* aptr):ptr(aptr){}

//transfer logic
ob_wrapper_for_table(const ob_wrapper_for_table& s):ptr(s.ptr){
((ob_wrapper_for_table*)(&s))->ptr=OB_NULL;
}

//transfer logic
ob_wrapper_for_table& operator =(const ob_wrapper_for_table& s){
delete ptr;
ptr=s.ptr;
((ob_wrapper_for_table*)(&s))->ptr=OB_NULL;
return *this;
}

ob_type_hashtablelength gethash(){return ptr->gethash();}

//get from wrapper
typestore* gfw(){return ptr;}
~ob_wrapper_for_table(){delete ptr;}
};

typedef ob_wrapper_for_table<ob_varone>       ob_type_wrapper_var;
typedef ob_wrapper_for_table<ob_vararray>     ob_type_wrapper_array;
typedef ob_wrapper_for_table<ob_api>          ob_type_wrapper_fun;
typedef ob_wrapper_for_table<ob_label_local>  ob_type_wrapper_label_local;
typedef ob_wrapper_for_table<ob_label_global> ob_type_wrapper_label_global;
typedef ob_wrapper_for_table<ob_forfor>       ob_type_wrapper_forfor;
typedef ob_wrapper_for_table<ob_base_file>    ob_type_wrapper_file;
typedef ob_wrapper_for_table<ob_type_name>    ob_type_wrapper_name;

typedef mhash<ob_type_wrapper_var,          ob_type_hashtablelength,ob_type_listlength> ob_type_table_var;
typedef mhash<ob_type_wrapper_array,        ob_type_hashtablelength,ob_type_listlength> ob_type_table_array;
typedef mhash<ob_type_wrapper_fun,          ob_type_hashtablelength,ob_type_listlength> ob_type_table_fun;
typedef mhash<ob_type_wrapper_label_local,  ob_type_hashtablelength,ob_type_listlength> ob_type_table_label_local;
typedef mhash<ob_type_wrapper_label_global, ob_type_hashtablelength,ob_type_listlength> ob_type_table_label_global;
typedef mhash<ob_type_wrapper_forfor,       ob_type_hashtablelength,ob_type_listlength> ob_type_table_forfor;
typedef mhash<ob_type_wrapper_file,         ob_type_hashtablelength,ob_type_listlength> ob_type_table_file;
typedef mhash<ob_type_wrapper_name,         ob_type_hashtablelength,ob_type_listlength> ob_type_table_name;

typedef mstack<ob_data_for_jump_global,ob_type_listlength>             ob_type_stack;

//functors for tables search
class ob_filefind{
const ob_type_filenum d;
public:

ob_filefind(const ob_type_filenum ddd):d(ddd){}

bool operator()(ob_type_wrapper_file& dd){
if(dd.gfw()->getnum()==d) return true; else return false;
}

ob_type_hashtablelength gethash(){
ob_type_hashtablelength ret=(ob_type_hashtablelength)d;
if(ret<0) ret=-ret;
return ret;
}
};

template <class typecompare,class typestore> class ob_hashfind{
typecompare* d;
ob_type_hashtablelength hashvalue;
public:
ob_hashfind(typecompare* ddd):d(ddd),hashvalue(ddd->gethash()){}

ob_type_hashtablelength gethash(){return hashvalue;}

bool operator()(typestore& dd){
if(dd.gethash()!=hashvalue) return false;
if((*(dd.gfw()))==(*d)) return true; else return false;
}
};

template<class typetable,class find>
bool
ob_replaceobjcommon1(find* f,typetable* table,typename typetable::tstorehash::tstore* tmpptr1){

typename typetable::tstorehash wrp_in(tmpptr1);

bool fl=table->replaceobj(f,&wrp_in,OB_NULL);
return fl;
}

template<class typetable>
bool
ob_replaceobjcommon2(typetable* table,typename typetable::tstorehash::tstore* tmpptr1,ob_type_namestatic* name){

ob_hashfind<ob_type_namestatic,typename typetable::tstorehash> findfunct(name);

return
ob_replaceobjcommon1<typetable,ob_hashfind<ob_type_namestatic,typename typetable::tstorehash> >(&findfunct,table,tmpptr1);
}

template<class typetable>
bool
ob_replaceobjcommon3(typetable* table,typename typetable::tstorehash::tstore* tmpptr1,ob_type_name* name){
ob_type_namestatic name1(name->c_str(),name->getcount());
return ob_replaceobjcommon2<typetable>(table,tmpptr1,&name1);
}

template <class typetable>
typename typetable::tstorehash::tstore* ob_findcommon(ob_type_namestatic* name,typetable* table){

ob_hashfind<ob_type_namestatic,typename typetable::tstorehash> findfunct(name);

typename typetable::tstorehash* current=table->findobj(&findfunct);
typename typetable::tstorehash::tstore* currentptr;

if(current!=OB_NULL) currentptr=current->gfw(); else currentptr=OB_NULL;
return currentptr;
}

template <class typetable>
typename typetable::tstorehash::tstore* ob_findcommon(ob_type_name* name,typetable* table){
ob_type_namestatic name1(name->c_str(),name->getcount());
return ob_findcommon<typetable>(&name1,table);
}

template <class typetable>
typename typetable::tstorehash::tstore* ob_findcommon(ob_type_char* name,typetable* table){
ob_type_namestatic name1(name);
return ob_findcommon<typetable>(&name1,table);
}

//##################################################################################

class ob_data_level1{

ob_type_table_var          tablevar;
ob_type_table_array        tablearray; 
ob_type_table_forfor       tableforfor;

public:

ob_data_level1(ob_type_hashtablelength tablelength):
tablevar(tablelength),
tablearray(tablelength), 
tableforfor(tablelength)
{}

virtual ~ob_data_level1(){clear_all();}

void clear_for_overlay(){
tableforfor.clear();
}

void clear_all(){
tablevar.clear();
tablearray.clear(); 
tableforfor.clear();
}

virtual ob_type_ident typevar(ob_type_char* name,ob_istream* in){
ob_varone* current=ob_findcommon<ob_type_table_var>(name,&tablevar);
if(current!=OB_NULL) return current->isA(); else return OB_NOIDENT;
}

virtual ob_type_ident typearray(ob_type_char* name,ob_istream* in){
ob_vararray* current=ob_findcommon<ob_type_table_array>(name,&tablearray);
if(current!=OB_NULL) return current->isA(); else return OB_NOIDENT;
}

virtual ob_varone*       findvar(ob_type_namestatic* name,ob_istream* in){return ob_findcommon<ob_type_table_var>(name,&tablevar);}
virtual ob_varone*       findvar(ob_type_char* name,ob_istream* in){return ob_findcommon<ob_type_table_var>(name,&tablevar);}
virtual ob_vararray*     findarray(ob_type_char* name,ob_istream* in){return ob_findcommon<ob_type_table_array>(name,&tablearray);}//for API
virtual ob_vararray*     findarray(ob_type_namestatic* name,ob_istream* in){return ob_findcommon<ob_type_table_array>(name,&tablearray);}
virtual ob_forfor*       findforfor(ob_type_name* name,ob_istream* in){return ob_findcommon<ob_type_table_forfor>(name,&tableforfor);}

virtual ob_varbase* putvar(ob_type_namestatic* name,ob_istream* in){

ob_varone* varoneptr=new ob_varone(*name);
ob_varbase* varptr=varoneptr;//need for return value

ob_wrapper_for_table<ob_varone> wrp(varoneptr);

tablevar.put(&wrp,name->gethash());
return varptr;
}

virtual ob_forfor* createforfor(ob_type_name* nameforfor,ob_savewrapper* last,ob_savewrapper* step,ob_type_streampos previousptr,ob_istream* in){
ob_forfor* tmpptr1=new ob_forfor(nameforfor,previousptr,last,step);
ob_replaceobjcommon3<ob_type_table_forfor>(&tableforfor,tmpptr1,nameforfor);
return tmpptr1;
}

virtual void createarray(ob_type_namestatic* namearraystatic,ob_type_dim* ptrdimcurrent,ob_istream* in){
ob_replaceobjcommon2<ob_type_table_array>(&tablearray,new ob_vararray(*namearraystatic,ptrdimcurrent),namearraystatic);
}

virtual const ob_type_arraysize* getarraysize(ob_type_char* name,ob_type_arraydimension* kr,ob_istream* in){

ob_vararray* current=ob_findcommon<ob_type_table_array>(name,&tablearray);

if(current!=OB_NULL)
return current->getsize(kr);
else
return OB_NULL;
}

virtual ob_data_for_jump_local* findlabel(ob_type_namestatic* name,ob_istream* in)=0;
virtual void put_label(ob_type_namestatic* name,ob_type_streampos mbl,ob_istream* in)=0;

};

class ob_data_level2: public ob_data_level1{

ob_type_table_label_global tablelabel;

public:

ob_data_level2(ob_type_hashtablelength tablelength):ob_data_level1(tablelength),tablelabel(tablelength){}

virtual ~ob_data_level2(){clear_all();}

void clear_for_overlay(){
ob_data_level1::clear_for_overlay();
tablelabel.clear();
}

void clear_all(){
ob_data_level1::clear_all();
tablelabel.clear();
}

virtual ob_data_for_jump_local* findlabel(ob_type_namestatic* name,ob_istream* in){return (ob_data_for_jump_local*)ob_findcommon<ob_type_table_label_global>(name,&tablelabel);}

virtual void put_label(ob_type_namestatic* name,ob_type_streampos mbl,ob_istream* in){
ob_type_wrapper_label_global wrp(new ob_label_global(name,mbl,in));
tablelabel.put(&wrp,name->gethash());
}

};

class ob_data_level3: public ob_data_level1{

ob_type_table_label_local tablelabel;
ob_type_istreamcommon*    streamptr;
ob_type_hashtablelength   hashvalue;
ob_type_string            string_id;

public:

ob_data_level3(ob_type_hashtablelength tablelength,ob_type_istreamcommon* streamptr1,ob_type_char* id):
ob_data_level1(tablelength),
tablelabel(tablelength),
streamptr(streamptr1),
hashvalue(ob_hash(streamptr1)),
string_id(id)
{}

virtual ~ob_data_level3(){clear_all();}

ob_type_istreamcommon* get_stream(){return streamptr;}

void clear_for_overlay(){
ob_data_level1::clear_for_overlay();
tablelabel.clear();
string_id.clear();
}

void clear_all(){
ob_data_level1::clear_all();
tablelabel.clear();
string_id.clear();
}

virtual ob_data_for_jump_local* findlabel(ob_type_namestatic* name,ob_istream* in){return (ob_data_for_jump_local*)ob_findcommon<ob_type_table_label_local>(name,&tablelabel);}

virtual void put_label(ob_type_namestatic* name,ob_type_streampos mbl,ob_istream* in){
ob_type_wrapper_label_local wrp(new ob_label_local(name,mbl));
tablelabel.put(&wrp,name->gethash());
}

ob_type_hashtablelength gethash(){return hashvalue;}
};

typedef ob_wrapper_for_table<ob_data_level3> ob_type_wrapper_for_data_level3;
typedef mhash<ob_type_wrapper_for_data_level3,ob_type_hashtablelength,ob_type_listlength> ob_type_table_object_local;

class ob_hashfind_table{
ob_type_istreamcommon* streamptr;
ob_type_hashtablelength hashvalue;
public:

ob_hashfind_table(ob_istream* streamptr1):hashvalue(streamptr1->gethash()),streamptr(streamptr1->get_stream()){}

ob_type_hashtablelength gethash(){return hashvalue;}

bool operator()(ob_type_wrapper_for_data_level3& dd){
ob_type_istreamcommon* ddd=dd.gfw()->get_stream();
if(ddd==streamptr) return true; else return false;
}
};

ob_data_level3* ob_findcommon_table(ob_type_table_object_local* table,ob_istream* streamptr1);

class ob_data_level4:public ob_data_level2{

ob_type_stack stackgosub;

public:

ob_data_level4(ob_type_hashtablelength tablelength):ob_data_level2(tablelength){}

virtual ~ob_data_level4(){ob_data_level2::clear_all();}

void clear_for_overlay(){
ob_data_level2::clear_for_overlay();
stackgosub.clear();
}

void clear_all(){
ob_data_level2::clear_all();
stackgosub.clear();
}

virtual void get_return_data_from_stack(ob_data_for_jump_global* data_for_return_operator){
stackgosub.get(data_for_return_operator);
}

virtual void put_return_data_to_stack(ob_istream* in){
ob_data_for_jump_global data_for_return_operator(in);
stackgosub.put(&data_for_return_operator);
}

virtual ob_type_listlength get_gousub_count(){return stackgosub.getcount();}

};

#define OB_RUNNER_ONE_ARG(aaaaaaa,bbbbbbb,cccccc,dddddddddddd)           \
virtual aaaaaaa bbbbbbb(dddddddddddd* name,ob_istream* in=OB_NULL){      \
aaaaaaa rrr=cccccc;                                                      \
                                                                         \
if(name!=OB_NULL){                                                       \
if(local_name_detect(name)==false){                                      \
rrr=ob_data_level4::bbbbbbb(name,in);                                    \
}                                                                        \
else{                                                                    \
ob_data_level3* level3_ptr=ob_findcommon_table(&table_local_object,in);  \
                                                                         \
if(level3_ptr!=OB_NULL){                                                 \
rrr=level3_ptr->bbbbbbb(name,in);                                        \
}                                                                        \
}                                                                        \
}                                                                        \
                                                                         \
return rrr;                                                              \
}

class ob_data_level5:public ob_data_level4{

ob_type_table_object_local table_local_object;

bool local_name_detect(ob_type_namestatic* name){return local_name_detect(name->getdata());}
bool local_name_detect(ob_type_name* name){return local_name_detect(name->getdata());}//for use in ob_obasic

public:

bool local_name_detect(ob_type_char* name){if(name[0]==ob_const_underscore) return true; else return false;}

ob_data_level5(ob_type_hashtablelength tablelength,ob_type_hashtablelength tablelengthlocal):
ob_data_level4(tablelength),
table_local_object(tablelengthlocal)
{}

virtual ~ob_data_level5(){clear_all();}

void clear_for_overlay(){
ob_data_level4::clear_for_overlay();
table_local_object.clear();
}

void clear_all(){
ob_data_level4::clear_all();
table_local_object.clear();
}

bool create_local_table(ob_type_hashtablelength tablelength,ob_istream* in,ob_type_char* id){

bool ret;

ob_data_level3* ptr_level3=ob_findcommon_table(&table_local_object,in);

if(ptr_level3==OB_NULL){

ob_type_wrapper_for_data_level3 wrp(new ob_data_level3(tablelength,in->get_stream(),id));

table_local_object.put(&wrp,wrp.gethash());

ret=true;
}//if
else{
ret=false;
}//else

return ret;
}

OB_RUNNER_ONE_ARG(ob_type_ident,typevar,OB_NOIDENT,ob_type_char)
OB_RUNNER_ONE_ARG(ob_type_ident,typearray,OB_NOIDENT,ob_type_char)
OB_RUNNER_ONE_ARG(ob_varone*,findvar,OB_NULL,ob_type_namestatic)
OB_RUNNER_ONE_ARG(ob_varone*,findvar,OB_NULL,ob_type_char)
OB_RUNNER_ONE_ARG(ob_vararray*,findarray,OB_NULL,ob_type_namestatic)
OB_RUNNER_ONE_ARG(ob_vararray*,findarray,OB_NULL,ob_type_char)
OB_RUNNER_ONE_ARG(ob_forfor*,findforfor,OB_NULL,ob_type_name)
OB_RUNNER_ONE_ARG(ob_varbase*,putvar,OB_NULL,ob_type_namestatic)

virtual ob_forfor* createforfor(ob_type_name* name,ob_savewrapper* last,ob_savewrapper* step,ob_type_streampos previousptr,ob_istream* in){
ob_forfor* ret=OB_NULL;

if(name!=OB_NULL){

if(local_name_detect(name)==true){
ob_data_level3* level3_ptr=ob_findcommon_table(&table_local_object,in);
                                                                         
if(level3_ptr!=OB_NULL){
ret=level3_ptr->createforfor(name,last,step,previousptr,in);
}//if
}//if
else{
ret=ob_data_level4::createforfor(name,last,step,previousptr,in);
}//else
}//if

return ret;
}

virtual void createarray(ob_type_namestatic* name,ob_type_dim* ptrdimcurrent,ob_istream* in){

if(name!=OB_NULL){

if(local_name_detect(name)==true){
ob_data_level3* level3_ptr=ob_findcommon_table(&table_local_object,in);
                                                                         
if(level3_ptr!=OB_NULL){
level3_ptr->createarray(name,ptrdimcurrent,in);
}//if
}//if
else{
ob_data_level4::createarray(name,ptrdimcurrent,in);
}//else
}//if

}

virtual const ob_type_arraysize* getarraysize(ob_type_char* name,ob_type_arraydimension* kr,ob_istream* in){
const ob_type_arraysize* ret=OB_NULL;

if(name!=OB_NULL){

if(local_name_detect(name)==true){
ob_data_level3* level3_ptr=ob_findcommon_table(&table_local_object,in);
                                                                         
if(level3_ptr!=OB_NULL){
ret=level3_ptr->getarraysize(name,kr,in);
}//if
}//if
else{
ret=ob_data_level4::getarraysize(name,kr,in);
}//else
}//if

return ret;
}

OB_RUNNER_ONE_ARG(ob_data_for_jump_local*,findlabel,OB_NULL,ob_type_namestatic)

virtual void put_label(ob_type_namestatic* name,ob_type_streampos mbl,ob_istream* in){

if(name!=OB_NULL){

if(local_name_detect(name)==true){
ob_data_level3* level3_ptr=ob_findcommon_table(&table_local_object,in);
                                                                         
if(level3_ptr!=OB_NULL){
level3_ptr->put_label(name,mbl,in);
}//if
}//if
else{
ob_data_level4::put_label(name,mbl,in);
}//else
}//if

}

};

class ob_subroutine:public ob_label_global{

ob_type_table_var         tablevar;   //ob_varone                        1
ob_type_table_array       tablearray; //ob_vararray                      2
ob_type_table_label_local tablelabel; //ob_label                         3
ob_type_table_forfor      tableforfor;//ob_forfor                        4
ob_type_stack             stackgosub;//                                  5

ob_type_table_name   formal_parameter_input;  //ob_type_name        6
ob_type_table_name   formal_parameter_input_output;  //ob_type_name 7

public:

ob_type_table_var*         get_tablevar()   {return &tablevar;}
ob_type_table_array*       get_tablearray() {return &tablearray;}
ob_type_table_label_local* get_tablelabel() {return &tablelabel;}
ob_type_table_forfor*      get_tableforfor(){return &tableforfor;}
ob_type_stack*             get_stackgosub() {return &stackgosub;}
ob_type_table_name*        get_table_formal_parameter_input(){return &formal_parameter_input;}
ob_type_table_name*        get_table_formal_parameter_input_output(){return &formal_parameter_input_output;}

ob_subroutine(
ob_type_namestatic* name,
ob_type_streampos p,
ob_istream* i1):
tablevar(ob_hashlength),
tablearray(ob_hashlength),
tablelabel(ob_hashlength),
tableforfor(ob_hashlength),
formal_parameter_input(ob_hashlength),
formal_parameter_input_output(ob_hashlength),
ob_label_global(name,p,i1){}

void clearsubroutine_for_overlay(){
tableforfor.clear();
tablelabel.clear();
stackgosub.clear();
}

void clearsubroutine_for_exit(){
tablevar.clear();
tablearray.clear();
tableforfor.clear();
stackgosub.clear();
}

void clearsubroutine_all(){
clearsubroutine_for_exit();
tablelabel.clear();
formal_parameter_input.clear();
formal_parameter_input_output.clear();
}

~ob_subroutine(){clearsubroutine_all();}

};

typedef ob_wrapper_for_table<ob_subroutine>     ob_type_wrapper_subroutine;
typedef mhash<ob_type_wrapper_subroutine,ob_type_hashtablelength,ob_type_listlength> ob_type_table_subroutine;

//##################################################################################

class ob_table_system{

ob_type_table_fun tablefun;

public:

ob_table_system(ob_type_hashtablelength tablelength):tablefun(tablelength){}

~ob_table_system(){clear_all();}

void clear_for_overlay(){}

void clear_all(){tablefun.clear();}
void clrtablfun(){tablefun.clear();}

template <class Tobapi> bool setfun(ob_type_char* name,Tobapi* ptr){
ob_type_namestatic a(name);
return ob_replaceobjcommon2<ob_type_table_fun>(&tablefun,ptr,&a);
}

bool delfun(ob_type_char* name){

ob_type_namestatic a(name);
ob_hashfind<ob_type_namestatic,ob_type_wrapper_fun> findfunct(&a);

ob_type_wrapper_fun wrp;

return tablefun.get(&findfunct,&wrp);
}

ob_api* findfun(ob_type_namestatic* name){return ob_findcommon<ob_type_table_fun>(name,&tablefun);}
};

class ob_table_project{

ob_type_table_file       tablefile;
ob_type_table_name       tablecheckload;
ob_type_table_subroutine tablesubroutine;
ob_type_stack            stacksubroutine;

public:

ob_table_project(ob_type_hashtablelength tablelength):
tablefile(tablelength),
tablecheckload(tablelength),
tablesubroutine(tablelength)
{}

~ob_table_project(){clear_all();}

void clear_all(){
tablefile.clear();
tablecheckload.clear();
tablesubroutine.clear();
stacksubroutine.clear();
}

void clear_for_overlay(){
tablefile.clear();
tablecheckload.clear();
tablesubroutine.clear();
stacksubroutine.clear();
}

void put_checkloadstring(ob_type_namestatic* str1){
ob_type_wrapper_name wrn(new ob_type_name(*str1));
tablecheckload.put(&wrn,wrn.gethash());
}

ob_type_name* find_checkloadstring(ob_type_namestatic* str1){return ob_findcommon<ob_type_table_name>(str1,&tablecheckload);}

//for operator CLEAR without parameters (close all file)
void cleartablefile(){tablefile.clear();}

void open_file(ob_type_filenum number,ios::openmode mode,ob_type_string* filename){

ob_filefind filefind(number);

if(mode==ios::out){
ob_replaceobjcommon1<ob_type_table_file,ob_filefind>(&filefind,&(tablefile),(ob_base_file*)new ob_output_file(filename->c_str(),mode,number));
}//if
else{
ob_replaceobjcommon1<ob_type_table_file,ob_filefind>(&filefind,&(tablefile),(ob_base_file*)new ob_input_file(filename->c_str(),mode,number));
}//else
}

void close_file(ob_type_filenum number){

ob_filefind filefind(number);

ob_type_wrapper_file wrp;//delete data after "get" by wrp destructor

tablefile.get(&filefind,&wrp);
}

ob_base_file* findfile(ob_type_filenum number){

ob_filefind filefind(number);

ob_type_wrapper_file* current=tablefile.findobj(&filefind);
ob_base_file* currentptr;

if(current!=OB_NULL) currentptr=current->gfw(); else currentptr=OB_NULL;
return currentptr;
}

ob_type_listlength get_subroutine_count(){return stacksubroutine.getcount();}

};

#define OB_MAX_NESTED_GOSUB_DEFAULT (4096)

class ob_obasic{

private:

ob_obasic& operator=(ob_obasic& ob){return *this;}

ob_obasic(ob_obasic& ob):

table_system(ob_hashlength),
table_project(ob_hashlength),
table_default_subroutine(ob_hashlength,ob_hashlength_local_object),

baselex(OB_NULL),
readlex(OB_NULL),
read_from_file_lex(OB_NULL),
datalex(OB_NULL),
datastream(OB_NULL)
{}

friend class ob_lex;

public:

enum loadresult{LOAD_OK,CHECKLOAD_DUPLICATE,STREAM_DUPLICATE,STREAM_NULL};
enum typeload{OVERLAY,NOOVERLAY};
enum step{NOSTEP,STEP};
enum typeend{DUMMYEND,ENDFILEEND,ENDOPERATORDETECT,EOLEND,BREAKPOINTEND,NOLOADEND};

private:

step stepflag;
bool flag_checkload;

void set_flag_checkload(bool fl){flag_checkload=fl;};
bool get_flag_checkload(){return flag_checkload;};

//static variable
static const ob_type_small_char* aboutmsg;
//for version 1.50
static const ob_type_serialnum sernum;
static const ob_type_version ver;

//non-static variable
typeend te;//for return value. need member for reenter after bef/aft oper break
bool endoperatordetect;//for exit if END operator detect
void setendoperatordetect(bool fl){endoperatordetect=fl;}

//keywords
ob_type_namestatic ob_THENkwrd;        //1
ob_type_namestatic ob_TOkwrd;          //2
ob_type_namestatic ob_STEPkwrd;        //3
ob_type_namestatic ob_OUTPUTkwrd;      //4
ob_type_namestatic ob_ASkwrd;          //5
ob_type_namestatic ob_FILEkwrd;        //6
ob_type_namestatic ob_EMPTYkwrd;       //7
ob_type_namestatic ob_SHARPkwrd;       //8 

//keywords as operator's name
ob_type_namestatic ob_PRINTkwrd;       //9
ob_type_namestatic ob_INPUTkwrd;       //10 
ob_type_namestatic ob_IFkwrd;          //11
ob_type_namestatic ob_FORkwrd;         //12
ob_type_namestatic ob_NEXTkwrd;        //13
ob_type_namestatic ob_GOTOkwrd;        //14
ob_type_namestatic ob_GOSUBkwrd;       //15 
ob_type_namestatic ob_RETURNkwrd;      //16
ob_type_namestatic ob_LETkwrd;         //17
ob_type_namestatic ob_DIMkwrd;         //18
ob_type_namestatic ob_STOPkwrd;        //19
ob_type_namestatic ob_ENDkwrd;         //20
ob_type_namestatic ob_REMkwrd;         //21
ob_type_namestatic ob_OPENkwrd;        //22
ob_type_namestatic ob_CLOSEkwrd;       //23
ob_type_namestatic ob_KILLkwrd;        //24
ob_type_namestatic ob_READkwrd;        //25
ob_type_namestatic ob_DATAkwrd;        //26
ob_type_namestatic ob_RESTOREkwrd;     //27 
ob_type_namestatic ob_RANDOMIZEkwrd;   //28
ob_type_namestatic ob_ELSEkwrd;        //29
ob_type_namestatic ob_ENDIFkwrd;       //30

//for version 1.91
ob_type_namestatic ob_SUBkwrd;         //31
ob_type_namestatic ob_ENDSUBkwrd;      //32
ob_type_namestatic ob_EXITSUBkwrd;     //33
ob_type_namestatic ob_CHECKLOADkwrd;   //34
ob_type_namestatic ob_VARkwrd;         //35

//containers
ob_operator tableoperator[ob_maxnumoperator];

ob_table_system  table_system;
ob_table_project table_project;
ob_data_level5   table_default_subroutine;

//variables
ob_lex baselex;
ob_lex readlex;
ob_lex read_from_file_lex;
ob_lex datalex;

ob_ostream out;//out for PRINT operator (need open in text mode)
ob_type_shortstrstream* datastream;//for DATA operator, create in load

ob_operator* tmpoperator;//for run operator because baselex::currentoperator can overwrite

//for version 1.90
ob_type_listlength maxnestedgosub;

template <bool flcreate>
ob_savewrapper* get_access(ob_type_char *name,ob_type_arraysize* as,ob_type_istreamcommon* i){

if(as==OB_NULL){//access to var (may be access to local var)

ob_istream in(i);

ob_varone* current=get_common_table()->findvar(name,&in);

if(current!=OB_NULL){
ob_savewrapper* sw=current->get();
return sw;
}//if
else{

if(flcreate==false){
return OB_NULL;
}//if
else{
ob_varbase* varptr;
ob_type_namestatic namestatic(name);
varptr=get_common_table()->putvar(&namestatic,&in);
return varptr->get();
}//else

}//else

}//if
else{//access to array (may be access to local array)

ob_istream in(i);

ob_vararray* current=get_common_table()->findarray(name,&in);
ob_type_arraydimension kr;

if(current!=OB_NULL){
current->getsize(&kr);
ob_type_dim ptrdimcurrent(as,kr);
current->setsize(&ptrdimcurrent);
ob_savewrapper* sw=current->get();
return sw;
}//if
else{
return OB_NULL;
}//else

}//else

}

template <class ob_type>
bool readvar1(
ob_type_char* name,
typename ob_type::typedatavar* val,
ob_type_arraysize* as,
ob_type_istreamcommon* i){

bool ret;

ob_savewrapper* aaa;

aaa=get_access<false>(name,as,i);

if(aaa==OB_NULL){
ret=false;
}//if
else{
aaa->cast(val);
ret=true;
}//else

return ret;
}

template <class ob_type>
bool writevar1(
ob_type_char* name,
typename ob_type::typedatavar val,
ob_type_arraysize* as,
ob_type_istreamcommon* i){

bool ret;

ob_savewrapper* aaa;

aaa=get_access<true>(name,as,i);

if(aaa==OB_NULL){
ret=false;
}//if
else{
ob_savewrapper aa(new ob_type(val));
aaa->asg(&aa);
ret=true;
}//else

return ret;
}

ob_operator* findoperator(ob_type_namestatic* namestatic);//setbreak and get_lex

void createarray(ob_type_namestatic* namearraystatic,ob_type_dim* ptrdimcurrent,ob_istream* in){
get_common_table()->createarray(namearraystatic,ptrdimcurrent,in);
}

loadresult load1(ob_type_istreamcommon* i,ob_type_char* id);
typeend run1();

template<class T>
bool set_get_operatorbreak(ob_type_char* name,T b){
bool ret=true;

ob_type_namestatic namestatic(name);
ob_operator* current=findoperator(&namestatic);

if(current==OB_NULL) ret=false; else current->set_get_break(b);

return ret;
}

void clrtabl(typeload a){

if(a==OVERLAY){
table_project.clear_for_overlay();
table_default_subroutine.clear_for_overlay();
}//if

if(a==NOOVERLAY){

if(datastream!=NULL) delete datastream;
datastream=NULL;

table_project.clear_all();
table_default_subroutine.clear_all();
}//if

}

public:

//ob_obasic(ob_type_ostreamcommon* o=&cout,ob_type_istreamcommon* rd=&cin);
ob_obasic();

virtual ~ob_obasic(){
table_system.clear_all();
clear_project();
clrtabl(NOOVERLAY);
}

static const ob_type_small_char* about(){return aboutmsg;}

loadresult load(ob_type_istreamcommon* i,ob_type_char* id=OB_NULL,typeload a=ob_obasic::NOOVERLAY){
//clear old ptr and clear old tablelabel and tablevar
clrtabl(a);
return load1(i,id);
}

void clear_project(){
clrtabl(NOOVERLAY);
endoperatordetect=false;
}

void clrtablfun(){table_system.clrtablfun();}

loadresult load_project(ob_type_istreamcommon* i,ob_type_char* id){return load1(i,id);}

//for ob_loadbreakstr
//for create label
//for local variable access
ob_type_istreamcommon* get_current_input_stream(){
return baselex.get_input_stream()->get_stream();
}

//for run
void set_current_input_stream(ob_type_istreamcommon* i){
baselex.get_input_stream()->set_stream(i);
}

typeend run(){return run1();}

void setstep(step ts){stepflag=ts;}
step getstep() const {return stepflag;}

//for API variable and array
ob_type_ident typevar(ob_type_char* name,ob_type_istreamcommon* i=OB_NULL){
ob_istream in(i);
return get_common_table()->typevar(name,&in);
}

ob_type_ident typearray(ob_type_char* name,ob_type_istreamcommon* i=OB_NULL){
ob_istream in(i);
return get_common_table()->typearray(name,&in);
}

void createvar(ob_type_char* name,ob_type_istreamcommon* i=OB_NULL){
get_access<true>(name,OB_NULL,i);
}

void createarray(ob_type_char* name,ob_type_arraydimension kr,ob_type_arraysize* as,ob_type_istreamcommon* i=OB_NULL){
ob_type_namestatic namearraystatic(name);
ob_type_dim ptrdimcurrent(as,kr);
ob_istream in(i);
createarray(&namearraystatic,&ptrdimcurrent,&in);
}

ob_type_ident
strlenvar(
ob_type_char* name,
ob_type_stringsize* len,
ob_type_arraysize* as=OB_NULL,
ob_type_istreamcommon* i=OB_NULL){

ob_type_ident ret=OB_NOIDENT;

ob_savewrapper* aaa;

if((aaa=get_access<false>(name,as,i))!=OB_NULL){
ret=aaa->isA();
*len=aaa->size();
}//if

return ret;
}

bool writevar(ob_type_char* name,ob_type_flo val,ob_type_arraysize* as=OB_NULL,ob_type_istreamcommon* i=OB_NULL){return writevar1<ob_float>(name,val,as,i);}
bool writevar(ob_type_char* name,ob_type_int val,ob_type_arraysize* as=OB_NULL,ob_type_istreamcommon* i=OB_NULL){return writevar1<ob_int>(name,val,as,i);}
bool writevar(ob_type_char* name,ob_type_char* val,ob_type_arraysize* as=OB_NULL,ob_type_istreamcommon* i=OB_NULL){return writevar1<ob_str>(name,val,as,i);}

bool readvar(ob_type_char* name,ob_type_flo* val,ob_type_arraysize* as=OB_NULL,ob_type_istreamcommon* i=OB_NULL){return readvar1<ob_float>(name,val,as,i);}
bool readvar(ob_type_char* name,ob_type_int* val,ob_type_arraysize* as=OB_NULL,ob_type_istreamcommon* i=OB_NULL){return readvar1<ob_int>(name,val,as,i);}

bool
readvar(ob_type_char* name,ob_type_char* val,ob_type_arraysize* as=OB_NULL,ob_type_istreamcommon* i=OB_NULL){

bool ret;

ob_savewrapper* aaa;
ob_type_char* val1;

aaa=get_access<false>(name,as,i);

if(aaa==OB_NULL){
ret=false;
}//if
else{
aaa->cast(&val1);
ob_strcpy(val,val1);
ret=true;
}//else

return ret;
}

const ob_type_arraysize* getarraysize(ob_type_char* name,ob_type_arraydimension* kr,ob_type_istreamcommon* i=OB_NULL){
ob_istream in(i);
return get_common_table()->getarraysize(name,kr,&in);
}

//for API user function
bool setfun(ob_type_char* name,ob_type_flofun f){return table_system.setfun<ob_apif>(name,new ob_apif(name,f));}
bool setfun(ob_type_char* name,ob_type_intfun f){return table_system.setfun<ob_apii>(name,new ob_apii(name,f));}
bool setfun(ob_type_char* name,ob_type_charfun f,ob_type_del dt){return table_system.setfun<ob_apic>(name,new ob_apic(name,f,dt));}

//for version 1.50
bool delfun(ob_type_char* name){return table_system.delfun(name);}

static ob_type_serialnum serial_number(){return sernum;}
static ob_type_int version(){return ver;}

bool setoperatorbreak(ob_type_char* name,ob_base_class_for_IO_service* b){
return set_get_operatorbreak(name,b);
}

bool getoperatorbreak(ob_type_char* name,ob_base_class_for_IO_service** b){
return set_get_operatorbreak(name,b);
}

void setin(ob_type_istreamcommon* i){readlex.get_input_stream()->set_stream(i);}
void setout(ob_type_ostreamcommon* o){out.set_stream(o);}

ob_lex::typelex gettypenextlex(){return baselex.gettypecurrentlex();}

//for version 1.90
void set_max_nested_gosub(ob_type_listlength m){maxnestedgosub=m;}
ob_type_listlength get_max_nested_gosub(){return maxnestedgosub;}

//for version 1.91
bool checkfun(ob_type_char* name){
bool ret;

ob_type_namestatic name1(name);

ob_api* ptrapi=table_system.findfun(&name1);
if(ptrapi==OB_NULL) ret=false; else ret=true; 
return ret;
}

ob_table_system*  get_table_system()         {return &table_system;}
ob_table_project* get_table_project()        {return &table_project;}
ob_data_level5*   get_default_subroutine()   {return &table_default_subroutine;}

ob_data_level4* get_common_table(){

ob_data_level4* ret;

if(table_project.get_subroutine_count()==ob_type_listlength()){
ret=&table_default_subroutine;
}//if
else{
}//else

return ret;
}

bool local_name_detect(ob_type_char* name){return get_default_subroutine()->local_name_detect(name);}

};//end class ob_obasic

class ob_err{
ob_type_codeerror code;                        
public:
ob_err(ob_type_codeerror c){code=c;}

virtual void release(ob_type_ostreamcommon* os,const ob_type_small_char* currentmessage[]){
(*os)<<endl<<(currentmessage)[code-ob_basecodeerror];
(*os)<<endl<<"code error= "<<(code-ob_basecodeerror);
(*os)<<endl;
}

virtual ob_type_codeerror getcode(){return code;}
virtual ~ob_err(){}
};

//prototypes
void ob_allocspaceforvar(
ob_type_namestatic* str,ob_savewrapper* value,ob_type_arraysize size);//for varone and vararray

bool ob_loadbreakstr(
ob_type_istreamcommon* in,
ob_type_stringsize lengthbuffers,
ob_type_char* ptrbefore,
ob_type_char* ptrcurrent,
ob_type_char* ptrafter);

ob_type_int ob_hexconvert(ob_type_char* a);

OB_DECLARE_USER_FUNCTION(ob_fun_rnd,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_abs,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_sin,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_cos,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_atn,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_sqr,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_exp,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_log,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_log10,ob_type_flo);
OB_DECLARE_USER_FUNCTION(ob_fun_int,ob_type_int);
OB_DECLARE_USER_FUNCTION(ob_fun_sgn,ob_type_int);
OB_DECLARE_USER_FUNCTION(ob_fun_len,ob_type_int);
OB_DECLARE_USER_FUNCTION(ob_fun_dat,ob_type_char*);
OB_DECLARE_USER_FUNCTION(ob_fun_clk,ob_type_char*);
OB_DECLARE_USER_FUNCTION(ob_fun_digit2str,ob_type_char*);
OB_DECLARE_USER_FUNCTION(str2flo,ob_type_flo);
OB_DECLARE_USER_FUNCTION(str2int,ob_type_int);
OB_DECLARE_USER_FUNCTION(ob_fun_digit2hexstr,ob_type_char*);

}//end namespace 

#endif

